WebApplication_StudentManagement_PrizeTest/WebApplication_StudentManagement_PrizeTest/Controllers/CourseController.cs
using AutoMapper;
using StudentManagement_DAL.Manager;
using StudentManagement_Model.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using WebApplication_StudentManagement_PrizeTest.Models;

namespace WebApplication_StudentManagement_PrizeTest.Controllers
{
    public class CourseController : BaseController
    {
        // GET: Course
        public ActionResult Index()
        {
            List<CourseViewModel> courseList = new List<CourseViewModel>();
            using (CourseManager courseMnger = new CourseManager())
            {
                var modelCourseDB = courseMnger.GetAllCourse();
                Mapper.Configuration.CreateMapper();
                courseList = Mapper.Map<List<Course>, List<CourseViewModel>>(modelCourseDB);
            }
            return View(courseList);
        }

        // GET: Course/Create
        public ActionResult Create()
        {
            CourseViewModel model = new CourseViewModel();
            return PartialView(model);
        }

        // POST: Course/Create
        [HttpPost]
        public ActionResult Create(CourseViewModel model)
        {
            bool result = false;
            if (ModelState.IsValid)
            {
                using (CourseManager courseMngr = new CourseManager())
                {
                    Course updateDBModel = new Course();
                    updateDBModel.CourseName = model.CourseName;
                    updateDBModel.StartDate = model.StartDate;
                    updateDBModel.EndDate = model.EndDate;
                    result = courseMngr.CreateCourse(updateDBModel);
                }
            }
            else
            {
                return base.RaiseError("Invalid course information.");
            }

            if (result)
            {
                return base.RaiseSuccess("Updated Successfully");
            }
            else
            {
                return base.RaiseError("Update Failed");
            }
        }
    }
}

WebApplication_StudentManagement_PrizeTest/WebApplication_StudentManagement_PrizeTest/Controllers/HomeController.cs
using StudentManagement_DAL.Constants;
using StudentManagement_DAL.Manager;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using WebApplication_StudentManagement_PrizeTest.Models;

namespace WebApplication_StudentManagement_PrizeTest.Controllers
{
    public class HomeController : BaseController
    {
        public ActionResult Index()
        {
            StudentCourseViewModel model = new StudentCourseViewModel();
            using (StudentManager stuManager = new StudentManager())
            {
                model.Students = stuManager.PopulateStudent();
            }

            using (CourseManager courseManager = new CourseManager())
            {
                model.Courses = courseManager.PopulateCourse();
            }

            return View(model);
        }        
    }
}

WebApplication_StudentManagement_PrizeTest/WebApplication_StudentManagement_PrizeTest/Controllers/StudentController.cs
using AutoMapper;
using StudentManagement_DAL.Manager;
using StudentManagement_Model.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using WebApplication_StudentManagement_PrizeTest.Models;

namespace WebApplication_StudentManagement_PrizeTest.Controllers
{
    public class StudentController : BaseController
    {
        // GET: Student
        public ActionResult Index()
        {
            List<StudentViewModel> model = new List<StudentViewModel>();
            using (StudentManager stuMnger = new StudentManager())
            {
                var modelStudentDB = stuMnger.GetAllStudent();
                Mapper.Configuration.CreateMapper();
                model = Mapper.Map<List<Student>, List<StudentViewModel>>(modelStudentDB);
            }

            return View(model);
        }
        
        // GET: Student/Create
        public ActionResult Create()
        {
            StudentViewModel model = new StudentViewModel();
            return PartialView(model);
        }

        // POST: Student/Create
        [HttpPost]
        public ActionResult Create(StudentViewModel model)
        {
            bool result = false;
            if (ModelState.IsValid)
            {
                using (StudentManager studentMngr = new StudentManager())
                {
                    Student updateDBModel = new Student();
                    updateDBModel.FirstName = model.FirstName;
                    updateDBModel.Surname = model.Surname;
                    updateDBModel.EmailAddress = model.EmailAddress;
                    updateDBModel.IDNumber = model.IDNumber;
                    result = studentMngr.CreateStudent(updateDBModel);
                }
            }
            else
            {
                return base.RaiseError("Invalid student information.");
            }

            if (result)
            {
                return base.RaiseSuccess("Updated Successfully");
            }
            else
            {
                return base.RaiseError("Update Failed");
            }
        }
    
    }
}

WebApplication_StudentManagement_PrizeTest/WebApplication_StudentManagement_PrizeTest/Controllers/StudentCourseController.cs
using AutoMapper;
using StudentManagement_DAL.Constants;
using StudentManagement_DAL.Manager;
using StudentManagement_Model.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using WebApplication_StudentManagement_PrizeTest.Models;

namespace WebApplication_StudentManagement_PrizeTest.Controllers
{
    public class StudentCourseController : BaseController
    {
        // GET: StudentCourse
        public ActionResult Index()
        {
            List<Student_Course_Info_ViewModel> model = new List<Student_Course_Info_ViewModel>(); 
            using (StudentCourseManager stuCMnger = new StudentCourseManager())
            {
                var modelStudentCourseDB = stuCMnger.GetAllStudent_Course();
                Mapper.Configuration.CreateMapper();
                model = Mapper.Map<List<Student_Course>, List<Student_Course_Info_ViewModel>>(modelStudentCourseDB);
            }
            return PartialView(model);
        }

        public ActionResult AddStudentCourse(int studentId, int courseId)
        {
            bool result = false;
            using (StudentCourseManager stuCourseMngr = new StudentCourseManager())
            {
                if (stuCourseMngr.IsCourseAlreadyAssignedStudent(studentId, courseId))
                {
                    return base.RaiseError("Each course should not be assigned more than once to a student");
                }

                if (stuCourseMngr.IsStudentRegisteredMoreThanNCourse(studentId))
                {
                    return base.RaiseError(string.Format("A student should not be assigned more than {0} courses", StudentCourseConstant.MAXIMUMREGISTRATIONCOURSE));
                }

                //if we got here lets insert
                result = stuCourseMngr.AddStudentCourse(studentId, courseId);
            }

            if (result)
            {
                return base.RaiseSuccess("Updated Successfully");
            }
            else
            {
                return base.RaiseError("Update Failed");
            }
        }
    }
}

WebApplication_StudentManagement_PrizeTest/WebApplication_StudentManagement_PrizeTest/Views/Home/About.cshtml
@{
    ViewBag.Title = "About";
}
<h2>@ViewBag.Title.</h2>
<h3>@ViewBag.Message</h3>

<p>Use this area to provide additional information.</p>

WebApplication_StudentManagement_PrizeTest/WebApplication_StudentManagement_PrizeTest/Views/Home/Contact.cshtml
@{
    ViewBag.Title = "Contact";
}
<h2>@ViewBag.Title.</h2>
<h3>@ViewBag.Message</h3>

<address>
    One Microsoft Way<br />
    Redmond, WA 98052-6399<br />
    <abbr title="Phone">P:</abbr>
    425.555.0100
</address>

<address>
    <strong>Support:</strong>   <a href="mailto:Support@example.com">Support@example.com</a><br />
    <strong>Marketing:</strong> <a href="mailto:Marketing@example.com">Marketing@example.com</a>
</address>

WebApplication_StudentManagement_PrizeTest/WebApplication_StudentManagement_PrizeTest/Views/Home/Index.cshtml
@using WebApplication_StudentManagement_PrizeTest.Models;
@model StudentCourseViewModel
@{
    ViewBag.Title = "Student Course Information";
}

<div>
    @Html.ActionLink("Capture Student", "Index", "Student") |
    @Html.ActionLink("Capture Course", "Index", "Course")
</div>
<hr />

<h4>Capture Student Course Assignment</h4>
<table class="tablealign">
    <tr>
        <td>
            <div>
                <label>Student</label>
            </div>
        </td>
        <td>
            <div class="editor-field">
                @Html.DropDownListFor(model => model.StudentId, @Model.Students, new { @id = "cmbStudent", @maxlength = "50", @style = "width:350px;height:35px" })
            </div>
        </td>
    </tr>
    <tr>
        <td>
            <div>
                <label>Course</label>
            </div>
        </td>
        <td>
            <div class="editor-field">
                @Html.DropDownListFor(model => model.CourseId, @Model.Courses, new { @id = "cmbCourse", @maxlength = "50", @style = "width:350px;height:35px" })
            </div>
        </td>
    </tr>
    <tr>
        <td>
            <div>
               
            </div>
        </td>
        <td>
            <div class="editor-field">
                <input id="addStudentCourse" type="button" class="btn btn-default addStudentCourse" value="Add Course" />
            </div>
        </td>
    </tr>
</table>

<hr />

<div id="Student_Course_Info_PartialViewDiv">
    @Html.Action("Index", "StudentCourse")
</div>

<script>
    $(".addStudentCourse").on("click", function (e) {
        $.ajax({
            type: "POST",
            url: '@Url.Action("AddStudentCourse", "StudentCourse")',
            data: { studentId: $('#cmbStudent').val(), courseId: $('#cmbCourse').val() },
            success: function (response) {
                if (response.success) {
                    window.location.reload();
                }
                AjaxOnSuccess(response);
            }
        });
    });
</script>